=== tests/sail-manip/CMakeLists.txt ===
sail_test(TARGET closest-conversion SOURCES closest-conversion.c LINK sail sail-manip)
