=== tests/sail/CMakeLists.txt ===
sail_test(TARGET io-produce-same-images SOURCES io-produce-same-images.c LINK sail sail-comparators)
