=== src/sail-codecs/tga/CMakeLists.txt ===
# Common codec configuration
#
sail_codec(NAME tga SOURCES helpers.h helpers.c tga.c ICON tga.png)
