=== debian/changelog ===
sail (0.9.0+repack-2) unstable; urgency=medium

  * Add dependency on sail-codecs. (Closes: #1059743)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 31 Dec 2023 22:45:06 +0000

sail (0.9.0+repack-1) unstable; urgency=medium

  * Initial release. (Closes: #1053729)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 15 Dec 2023 23:06:31 +0000
