=== debian/control ===
Source: sail
Section: libs
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13), libgif-dev, libjpeg-dev, cmake,
 libpng-dev, libtiff-dev, libavif-dev, libwebp-dev, libjxl-dev
Standards-Version: 4.6.2
Homepage: https://github.com/HappySeaFox/sail
Vcs-Browser: https://salsa.debian.org/sudip/sail
Vcs-Git: https://salsa.debian.org/sudip/sail.git

Package: libsail-common0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL common client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package contains the shared library.

Package: libsail-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-common0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL common client library (development files)
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package is needed to compile programs against libsail-common0.

Package: libsail-manip0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL image manipulation library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides image manipulation functions.
 .
 This package contains the shared library.

Package: libsail-manip-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-manip0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL image manipulation library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package is needed to compile programs against libsail-manip0.

Package: libsail0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, sail-codecs (= ${binary:Version})
Description: SAIL client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL client libraries.
 .
 This package contains the shared library.

Package: libsail-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL client library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL development headers and libraries.

Package: libsail-c++0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL C++ client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL client libraries.

Package: libsail-c++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-c++0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL C++ client library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL C++ development headers and libraries.

Package: sail-codecs
Architecture: any
Multi-Arch: same
Section: misc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL common image codecs
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides low-level SAIL image codecs.
